#! /usr/bin/env python
# -*- coding: utf-8 -*-

import sys, os, stat
argv = sys.argv

grubfile = "/etc/grub.d/01_emgd_915resolution"
modname  = "915resolution"
format   = """echo insmod %s
echo %s %s %s %s %s"""

def __interable__(str):
    try:
        int(str)
        return True
    except:
        return False

if len(argv) == 4:
    if argv[1] == "mk":
        reslist = argv[2].split("x")
        if len(reslist) == 3 and __interable__(argv[3]):
            file_content = format %(modname,
                                    modname,
                                    argv[3],
                                    reslist[0],
                                    reslist[1],
                                    reslist[2]
                                    )
            
            try:
                modfile = open(grubfile, "w")
                modfile.write(file_content)
                modfile.close()
                if not os.access(grubfile, os.X_OK):
                    os.chmod(grubfile, stat.S_IXUSR)
                    os.chmod(grubfile, stat.S_IXGRP)
                    os.chmod(grubfile, stat.S_IXOTH)
            except IOError:
                print "\n** Suggested %s: \n%s" %(grubfile, file_content)
    else:
        print "* Option <%s> not supported!" %(argv[1])
elif len(argv) == 2:
    if argv[1] == "rm":
        if os.path.isfile(grubfile):
            try:
                os.remove(grubfile)
            except OSError:
                print "* Can't remove: %s" %(grubfile)
    else:
        print "* Option <%s> not supported!" %(argv[1])